"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _moment = _interopRequireDefault(require("moment"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * 注意： 如果需要重置时，需传递 resetKey 随机值
 * @param onChange{Function} 时间改变回调事件
 * @param limit{Number} 起始日期间隔大小，不传限定
 * @param placeholder {Array} 日期框的占位符
 * @param fullRequest{Boolean} 是否需要选择2个时间才会触发 onChange
 * @param future{Boolean} 是可以选择未来时间
 * @param recentlyDay{Number} 只能选择最近多少天
 * @param resetKey{*} 每次传入不同的值时，日期就会重置
 * @param initialValue{*} 每次传入不同的值时，日期就会重置
 */
var DateRange = /*#__PURE__*/function (_Component) {
  _inherits(DateRange, _Component);

  var _super = _createSuper(DateRange);

  function DateRange(props) {
    var _this;

    _classCallCheck(this, DateRange);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "disabledDate", function (type, current) {
      var values = _this.state.values;
      var _this$props = _this.props,
          future = _this$props.future,
          recentlyDay = _this$props.recentlyDay; // 禁用未来时间

      var isAfter = (0, _moment["default"])(current.format('YYYY-MM-DD') + ' 00:00:00').isAfter((0, _moment["default"])((0, _moment["default"])().format('YYYY-MM-DD') + ' 00:00:00'));

      if (isAfter && !future) {
        return isAfter;
      } // 如果有recentlyDay（最近多少天），这recentlyDay之前都被禁用


      var recentlyDayDisabled = false;

      if (typeof recentlyDay === 'number') {
        var now = (0, _moment["default"])((0, _moment["default"])().format('YYYY-MM-DD') + ' 00:00:00').valueOf();
        var cur = (0, _moment["default"])(current.format('YYYY-MM-DD') + ' 00:00:00').valueOf(); // 是否在近期多少天内

        recentlyDayDisabled = cur < now - (recentlyDay - 1) * 24 * 60 * 60 * 1000;
      }

      if (type === 'start') {
        // 不能选择比结束日期还晚的时间,同一天可选
        return values[1] ? current.isSame(values[1], 'day') ? false : current.isAfter(values[1]) || recentlyDayDisabled : recentlyDayDisabled || false;
      } else {
        // 不能选择比开始日期还早的时间,同一天可选
        return values[0] ? current.isSame(values[0], 'day') ? false : current.isBefore(values[0]) || recentlyDayDisabled : recentlyDayDisabled || false;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function (type, date) {
      //fullRequest 两个都必须选择才会发生change事件
      var _this$props2 = _this.props,
          fullRequest = _this$props2.fullRequest,
          onChange = _this$props2.onChange,
          future = _this$props2.future; // 设置为全部选择完在触发时

      var values = _this.state.values;
      var limit = _this.props.limit;
      date = date ? (0, _moment["default"])(date.valueOf()) : date;

      var range = _toConsumableArray(values);

      if (type === 'start') {
        if (date) {
          range[0] = (0, _moment["default"])(date.format('YYYY-MM-DD') + ' 00:00:00');
        } else {
          range[0] = date;
        }
      } else {
        if (date) {
          // 未来时间时，则给出当前时间
          // 当天
          var now = (0, _moment["default"])((0, _moment["default"])().format('YYYY-MM-DD')); // 选择的日期

          var _date = (0, _moment["default"])(date.format('YYYY-MM-DD')); // 选择过去的日期


          if (_date.valueOf() < now.valueOf()) {
            var yearAndMonth = date.format('YYYY-MM'); // date 日期的月份的最后一天

            var lastDay = date.endOf('day').format('DD');
            range[1] = (0, _moment["default"])(yearAndMonth + '-' + lastDay + ' 23:59:59');
          } else {
            if (future) {
              // 允许选择未来时间
              range[1] = (0, _moment["default"])(date.format('YYYY-MM-DD') + ' 23:59:59');
            } else {
              range[1] = (0, _moment["default"])();
            }
          }
        } else {
          range[1] = date;
        }
      }

      _this.setState({
        values: range
      }); // 判断结束时间不能早于开始时间


      if (range.filter(function (e) {
        return e;
      }).length === 2) {
        var startIsAfterEnd = range[0].isAfter(range[1]);

        if (startIsAfterEnd) {
          _antd.message.info('结束日期不能早于开始日期');

          return;
        } // 结束日期与开始日期间隔不能大于 limit 天


        var end = (0, _moment["default"])(range[1].valueOf()).subtract(limit, 'day');

        if (typeof limit !== 'undefined') {
          if (end > range[0]) {
            _antd.message.info("\u8D77\u59CB\u65E5\u671F\u4E0D\u80FD\u8D85\u8FC7".concat(limit, "\u5929"));

            return;
          }
        }
      } // 设置必须都选都选择时，才会触发change事件


      if (fullRequest) {
        var hasEmpty = range.filter(function (e) {
          return !e;
        }).length;

        if (!hasEmpty) {
          onChange && onChange(range);
        } else {// message.info('请选择完整的查询日期')
        }
      } else {
        // 只要选择任意一个都会触发change事件
        // let _range = range.filter((e)=>e)
        // _range = _range.length === range ? range : _range
        onChange && onChange(range);
      }
    });

    var initialValue = props.initialValue;

    var _ref = initialValue || [null, null],
        _ref2 = _slicedToArray(_ref, 2),
        startValue = _ref2[0],
        endValue = _ref2[1];

    _this.state = {
      values: [startValue, endValue]
    };
    _this.preRestKey = props.resetKey;
    _this.nextResetKey = props.resetKey;
    return _this;
  }

  _createClass(DateRange, [{
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      if (nextProps.resetKey && this.nextResetKey !== nextProps.resetKey) {
        this.nextResetKey = nextProps.resetKey;
        var onChange = this.props.onChange;
        var values = nextProps.initialValue || [null, null]; //重置初始化日期

        this.setState({
          values: values
        });
        onChange && onChange(_toConsumableArray(values));
      }

      if (nextProps.value) {
        this.setState({
          values: nextProps.value
        });
      }
    } // 禁止选择的月份

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          _this$props3$format = _this$props3.format,
          format = _this$props3$format === void 0 ? 'YYYY-MM-DD' : _this$props3$format,
          style = _this$props3.style,
          _this$props3$placehol = _this$props3.placeholder,
          placeholder = _this$props3$placehol === void 0 ? ['开始日期', '结束日期'] : _this$props3$placehol,
          itemStyle = _this$props3.itemStyle,
          allowClear = _this$props3.allowClear;
      var obj = {
        allowClear: allowClear
      };

      var _this$state$values = _slicedToArray(this.state.values, 2),
          startValue = _this$state$values[0],
          endValue = _this$state$values[1]; // 重置时


      if (this.preRestKey !== this.nextResetKey) {
        // obj.value = null
        this.preRestKey = this.nextResetKey; // this.setState({ values: [] })
      } // console.log(startValue)


      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "daterange-custom",
        style: _objectSpread({}, style),
        key: this.nextResetKey
      }, /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, _extends({
        getCalendarContainer: function getCalendarContainer(triggerNode) {
          return triggerNode.parentNode;
        }
      }, obj, {
        value: startValue,
        format: format,
        placeholder: placeholder[0],
        style: _objectSpread({}, itemStyle),
        disabledDate: function disabledDate(date) {
          return _this2.disabledDate('start', date);
        },
        onChange: function onChange(date) {
          _this2.onChange('start', date);
        }
      })), /*#__PURE__*/_react["default"].createElement("span", {
        className: "split"
      }, "-"), /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, _extends({
        getCalendarContainer: function getCalendarContainer(triggerNode) {
          return triggerNode.parentNode;
        }
      }, obj, {
        value: endValue,
        format: format,
        placeholder: placeholder[1],
        style: _objectSpread({}, itemStyle),
        disabledDate: function disabledDate(date) {
          return _this2.disabledDate('end', date);
        },
        onChange: function onChange(date) {
          _this2.onChange('end', date);
        }
      })));
    }
  }]);

  return DateRange;
}(_react.Component);

exports["default"] = DateRange;

_defineProperty(DateRange, "propTypes", {
  limit: _propTypes["default"].number,
  fullRequest: _propTypes["default"].bool,
  recentlyDay: _propTypes["default"].number,
  future: _propTypes["default"].bool,
  placeholder: _propTypes["default"].array
});

_defineProperty(DateRange, "defaultProps", {
  fullRequest: false,
  // 是否必须两个选择完成才会发生请求
  future: false // 是可以选择未来时间
  // limit: 12 // 限制起始之间的间隔天数

});