"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _lodash = require("lodash");

var _DateRange = _interopRequireDefault(require("../DateRange"));

var _moment = _interopRequireDefault(require("moment"));

require("./index.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Option = _antd.Select.Option;
var TreeNode = _antd.TreeSelect.TreeNode;
var TextArea = _antd.Input.TextArea;

var renderPopverContent = function renderPopverContent(content) {
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "popover"
  }, content ? /*#__PURE__*/_react["default"].createElement(_antd.Tooltip, {
    title: content
  }, /*#__PURE__*/_react["default"].createElement(_antd.Icon, {
    type: "question-circle-o"
  })) : null);
}; // const PopoverInput = ({ inputType, name, placeholder, popover, ...other }) =>{
//   return (
//     <div>
//       <Input autoComplete="off" type={inputType} placeholder={placeholder || `请输入${name}`} className="form-item-warp" { ...other}/>
//       { renderPopverContent(popover) }
//     </div>
//   )
// }
// const renderIcon

/**
 * @param unAutoComplete 禁止自动填充
 */


var PopoverInput = /*#__PURE__*/function (_PureComponent) {
  _inherits(PopoverInput, _PureComponent);

  var _super = _createSuper(PopoverInput);

  function PopoverInput() {
    _classCallCheck(this, PopoverInput);

    return _super.apply(this, arguments);
  }

  _createClass(PopoverInput, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          inputType = _this$props.inputType,
          name = _this$props.name,
          placeholder = _this$props.placeholder,
          popover = _this$props.popover,
          show = _this$props.show,
          percent = _this$props.percent,
          unAutoComplete = _this$props.unAutoComplete,
          other = _objectWithoutProperties(_this$props, ["inputType", "name", "placeholder", "popover", "show", "percent", "unAutoComplete"]);

      return /*#__PURE__*/_react["default"].createElement("div", null, unAutoComplete && /*#__PURE__*/_react["default"].createElement(_antd.Input, {
        name: "hideText",
        style: {
          display: 'none'
        }
      }), inputType === 'passwordInput' ? /*#__PURE__*/_react["default"].createElement(_antd.Input.Password, _extends({
        autoComplete: unAutoComplete ? 'new-password' : 'off',
        placeholder: placeholder || "\u8BF7\u8F93\u5165".concat(name),
        className: "form-item-warp",
        suffix: percent && /*#__PURE__*/_react["default"].createElement("span", {
          className: "right-text"
        }, "%")
      }, other)) : /*#__PURE__*/_react["default"].createElement(_antd.Input, _extends({
        autoComplete: unAutoComplete ? 'new-password' : 'off',
        type: inputType,
        placeholder: placeholder || "\u8BF7\u8F93\u5165".concat(name),
        className: "form-item-warp",
        suffix: percent && /*#__PURE__*/_react["default"].createElement("span", {
          className: "right-text"
        }, "%")
      }, other)), renderPopverContent(popover));
    }
  }]);

  return PopoverInput;
}(_react.PureComponent);

var Detail = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var render = props.render,
      value = props.value;
  var result = render ? render() : value;
  return /*#__PURE__*/_react["default"].createElement("div", {
    ref: ref
  }, result);
});

var CommonForm = /*#__PURE__*/function (_PureComponent2) {
  _inherits(CommonForm, _PureComponent2);

  var _super2 = _createSuper(CommonForm);

  function CommonForm() {
    var _this;

    _classCallCheck(this, CommonForm);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super2.call.apply(_super2, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {});

    _defineProperty(_assertThisInitialized(_this), "renderPopverContent", function (content) {
      return /*#__PURE__*/_react["default"].createElement("span", {
        className: "popover"
      }, content ? /*#__PURE__*/_react["default"].createElement(_antd.Popover, {
        content: content,
        getPopupContainer: function getPopupContainer(triggerNode) {
          return triggerNode.parentNode;
        }
      }, /*#__PURE__*/_react["default"].createElement(_antd.Icon, {
        type: "question-circle"
      })) : null);
    });

    _defineProperty(_assertThisInitialized(_this), "validateEndTime", function (rule, value, callback, startTime) {
      var form = _this.props.form;

      if (value && (0, _moment["default"])(value).valueOf() < (0, _moment["default"])(form.getFieldValue(startTime)).valueOf()) {
        callback('预计结束时间应大于开始时间!');
      } else {
        callback();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "validateDateRange", function (rule, value, callback, message, singlebBefore) {
      if (!singlebBefore && !value[0] && message[0]) {
        callback(message[0]);
      } else if (!value[1] && message[1]) {
        callback(message[1]);
      } else {
        callback();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderPopover", function (text) {
      if (!text) return;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "popover-select"
      }, /*#__PURE__*/_react["default"].createElement(_antd.Popover, {
        content: text,
        getPopupContainer: function getPopupContainer(triggerNode) {
          return triggerNode.parentNode;
        },
        placement: "topLeft"
      }, /*#__PURE__*/_react["default"].createElement(_antd.Icon, {
        type: "question-circle"
      })));
    });

    _defineProperty(_assertThisInitialized(_this), "getPopupContainer", function (triggerNode) {
      var container = _this.props.container;

      if (container === 'form') {
        return triggerNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;
      }

      return triggerNode.parentNode;
    });

    _defineProperty(_assertThisInitialized(_this), "renderFormItem", function (filed, i) {
      var _this$props2 = _this.props,
          form = _this$props2.form,
          FormItem = _this$props2.FormItem,
          _this$props2$formLayo = _this$props2.formLayout,
          formLayout = _this$props2$formLayo === void 0 ? {} : _this$props2$formLayo;

      var _ref = form || {},
          getFieldDecorator = _ref.getFieldDecorator;

      var _ref2 = filed || {},
          type = _ref2.type,
          validateTrigger = _ref2.validateTrigger,
          name = _ref2.name,
          key = _ref2.key,
          rules = _ref2.rules,
          _ref2$inputType = _ref2.inputType,
          inputType = _ref2$inputType === void 0 ? 'text' : _ref2$inputType,
          placeholder = _ref2.placeholder,
          data = _ref2.data,
          config = _ref2.config,
          initialValue = _ref2.defaultValue,
          onSearch = _ref2.onSearch,
          popover = _ref2.popover,
          percent = _ref2.percent,
          max = _ref2.max,
          _ref2$scanData = _ref2.scanData,
          scanData = _ref2$scanData === void 0 ? [] : _ref2$scanData,
          hintContent = _ref2.hintContent,
          _ref2$fileLogo = _ref2.fileLogo,
          fileLogo = _ref2$fileLogo === void 0 ? '上传附件' : _ref2$fileLogo,
          _ref2$singlebBefore = _ref2.singlebBefore,
          singlebBefore = _ref2$singlebBefore === void 0 ? false : _ref2$singlebBefore,
          other = _objectWithoutProperties(_ref2, ["type", "validateTrigger", "name", "key", "rules", "inputType", "placeholder", "data", "config", "defaultValue", "onSearch", "popover", "percent", "max", "scanData", "hintContent", "fileLogo", "singlebBefore"]);

      var allowClear = other.allowClear,
          disabled = other.disabled,
          _other$showSearch = other.showSearch,
          showSearch = _other$showSearch === void 0 ? true : _other$showSearch; // 默认允许删除

      var _allowClear = {
        allowClear: true
      }; //设置不允许被删除或者禁用时，不允许被删除

      if (typeof allowClear === 'boolean' && !allowClear || disabled) {
        _allowClear.allowClear = false;
      }

      if (filed.component) {
        var Component = filed.component;
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: i
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })(Component));
      }

      if (type === 'hidden') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key,
          style: {
            display: 'none'
          }
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.Input, {
          autoComplete: "off",
          disabled: true,
          placeholder: placeholder || "\u8BF7\u8F93\u5165".concat(name),
          className: "form-item-warp"
        })));
      } else if (type === 'input') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(PopoverInput, _extends({}, _allowClear, {
          inputType: inputType,
          name: name,
          placeholder: placeholder,
          popover: popover
        }, other))));
      } else if (type === 'percentInput') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement("percentInput", _extends({}, _allowClear, {
          inputType: inputType,
          name: name,
          placeholder: placeholder,
          popover: popover
        }, other))));
      } else if (type === 'number') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.InputNumber, _extends({}, _allowClear, {
          placeholder: placeholder,
          formatter: function formatter(value) {
            return percent ? "".concat(value, "%") : value;
          },
          max: max
        }, other))));
      } else if (type === 'select') {
        var _ref3 = config || {},
            configName = _ref3.name,
            configValue = _ref3.value;

        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key,
          className: "form-item-container",
          extra: _this.renderPopover(popover)
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: !!initialValue ? initialValue : void 0
        })( /*#__PURE__*/_react["default"].createElement(_antd.Select, _extends({
          onSearch: onSearch,
          getPopupContainer: function getPopupContainer(triggerNode) {
            return _this.getPopupContainer(triggerNode);
          },
          placeholder: placeholder || "\u8BF7\u9009\u62E9".concat(name),
          className: "form-item-warp",
          optionFilterProp: "label",
          autocomplete: "off"
        }, other), (data || []).map(function (e) {
          var label = e[configName] || e.label || e.name || e.username || e.osName;
          var value = e[configValue] || e.value || e.stringId || e.os || e.osCode;
          return /*#__PURE__*/_react["default"].createElement(Option, {
            value: value,
            key: value,
            label: label,
            item: e
          }, label);
        }))));
      } else if (type === 'selectTree') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.TreeSelect, _extends({
          allowClear: true,
          treeDefaultExpandAll: true,
          className: "form-item-warp",
          getPopupContainer: function getPopupContainer(triggerNode) {
            return _this.getPopupContainer(triggerNode);
          },
          placeholder: placeholder || '请选择',
          treeNodeFilterProp: "title",
          showSearch: showSearch,
          onSearch: onSearch
        }, other), _this.renderCategoryModelNodeTree(data || [], config, 1))));
      } else if (type === 'date') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key,
          extra: _this.renderPopover(popover)
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, _extends({
          getPopupContainer: function getPopupContainer(triggerNode) {
            return _this.getPopupContainer(triggerNode);
          }
        }, other, {
          className: "form-item-warp modal-form-item-datepicker"
        })) // <DatePickerInput popover={popover} other={other}/>
        ));
      } else if (type === 'timePicker') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.TimePicker, _extends({
          getCalendarContainer: function getCalendarContainer(triggerNode) {
            return triggerNode.parentNode;
          }
        }, other, {
          className: "form-item-warp"
        }))));
      } else if (type === 'textArea') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(TextArea, _extends({
          placeholder: placeholder || '请输入',
          className: "form-item-warp"
        }, other, other))));
      } else if (type === 'dateRange') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          // rules,
          //
          rules: [{
            validator: function validator(rule, value, callback) {
              _this.validateDateRange(rule, value, callback, filed.rules[0].message, singlebBefore);
            }
          }],
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_DateRange["default"], other)));
      } else if (type === 'switch') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement("span", null, /*#__PURE__*/_react["default"].createElement(_antd.Switch, other), /*#__PURE__*/_react["default"].createElement("span", {
          className: "switch-label"
        }, filed.switchLabel || ''))));
      } else if (type === 'radioGroup') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.Radio.Group, other, (data || []).map(function (e) {
          return /*#__PURE__*/_react["default"].createElement(_antd.Radio, {
            value: e.value,
            key: e.value
          }, e.label);
        }))));
      } else if (type === 'checkboxGroup') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          validateTrigger: validateTrigger,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.Checkbox.Group, _extends({
          options: data || []
        }, other))));
      } else if (type === 'detail') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(Detail, other)));
      } else if (type === 'file') {
        return /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name
        }, formLayout, {
          key: filed.key
        }), getFieldDecorator(key, {
          rules: rules,
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.Upload, config, /*#__PURE__*/_react["default"].createElement("div", {
          className: "file-upload"
        }, /*#__PURE__*/_react["default"].createElement("img", {
          src: require('../../assets/images/file-upload.svg'),
          alt: ""
        }), fileLogo, /*#__PURE__*/_react["default"].createElement(_antd.Popover, {
          content: hintContent
        }, /*#__PURE__*/_react["default"].createElement(_antd.Icon, {
          type: "question-circle"
        }))))));
      } else if (type === 'startAndEndDatePicker') {
        return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name[0]
        }, formLayout, {
          key: filed.key[0]
        }), getFieldDecorator(key[0], {
          rules: [{
            required: rules[0].required,
            message: rules[0].message
          }],
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, {
          getCalendarContainer: function getCalendarContainer(triggerNode) {
            return triggerNode.parentNode;
          },
          disabledTime: _this.disabledDateTime,
          style: {
            width: '100%'
          },
          disabledDate: _this.disabledDate,
          showTime: {
            format: 'HH:mm:ss'
          },
          format: "YYYY-MM-DD HH:mm:ss",
          placeholder: placeholder[0],
          onChange: function onChange() {
            _this.onClickAgainStartDatePicker(key[1]);
          }
        }))), /*#__PURE__*/_react["default"].createElement(FormItem, _extends({
          label: name[1]
        }, formLayout, {
          key: filed.key[1]
        }), getFieldDecorator(key[1], {
          rules: [{
            required: rules[1].required,
            message: rules[1].message
          }, {
            validator: function validator(rule, value, callback) {
              _this.validateEndTime(rule, value, callback, filed.key[0]);
            }
          }],
          initialValue: initialValue
        })( /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, {
          getCalendarContainer: function getCalendarContainer(triggerNode) {
            return triggerNode.parentNode;
          },
          disabledTime: _this.disabledDateTime,
          style: {
            width: '100%'
          },
          disabledDate: _this.disabledDate,
          showTime: {
            format: 'HH:mm:ss'
          },
          format: "YYYY-MM-DD HH:mm:ss",
          placeholder: placeholder[1]
        }))));
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onClickAgainStartDatePicker", function (endTimeKey) {
      var form = _this.props.form;
      var endTime = form.getFieldValue(endTimeKey);
      setTimeout(function () {
        //validateFieldsAndScroll 校验完后，如果校验不通过的菜单域不在可见范围内，则自动滚动进可见范围
        if (endTime) form.validateFieldsAndScroll([endTimeKey], {
          force: true
        });
      }, 0);
    });

    _defineProperty(_assertThisInitialized(_this), "range", function (start, end) {
      var result = [];

      for (var i = start; i < end; i++) {
        result.push(i);
      }

      return result;
    });

    _defineProperty(_assertThisInitialized(_this), "disabledDate", function (timeValue) {
      var endValue = new Date();
      timeValue = new Date(timeValue);
      return timeValue.valueOf() + 86400000 < endValue.valueOf();
    });

    _defineProperty(_assertThisInitialized(_this), "disabledDateTime", function (current) {
      if (!current) return {
        disabledHours: function disabledHours() {
          return _this.range(0, 24);
        },
        disabledMinutes: function disabledMinutes() {
          return _this.range(0, 60);
        },
        disabledSeconds: function disabledSeconds() {
          return _this.range(0, 60);
        }
      };
      var hours = (0, _moment["default"])().hours();
      var minutes = (0, _moment["default"])().minutes();

      if ((0, _moment["default"])(current).format('YYYY-MM-DD') === (0, _moment["default"])(new Date()).format('YYYY-MM-DD')) {
        if ((0, _moment["default"])(current).hours() === hours) {
          return {
            disabledHours: function disabledHours() {
              return _this.range(0, hours);
            },
            disabledMinutes: function disabledMinutes() {
              return _this.range(0, minutes);
            }
          };
        } else {
          return {
            disabledHours: function disabledHours() {
              return _this.range(0, hours);
            }
          };
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderCategoryModelNodeTree", function () {
      var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var config = arguments.length > 1 ? arguments[1] : undefined;
      var levelType = arguments.length > 2 ? arguments[2] : undefined;

      var _ref4 = config || {},
          name = _ref4.name,
          value = _ref4.value,
          selectable = _ref4.selectable;

      return data.map(function (el) {
        // 所有节点可选
        el.disabled = false; // 含有节点选择的配置

        if (selectable) {
          /**
           * leafNode: 叶子节点可选，父节点，根节点不可选
           * parentNode: 叶子节点、父节点可选，根节点不可选
           * rootNode: 所有节点可选
           * leafNotRootNode: 末级节点非根节点可选（只有末级节点可选，如果只有一个节点，则不可选）
           */
          if (selectable === 'rootNode') {// 所有节点可选
          } else if (selectable === 'parentNode' && el.levelType <= 1) {
            // 1 代表的是更节点
            // 根节点禁止选择
            el.disabled = true;
          } else if (selectable === 'leafNode' && el.childrenNode && el.childrenNode.length) {
            // 根节点、父节点禁止选择
            el.disabled = true;
          } else if (selectable === 'childNode' && el.parentId === '1') {
            // 用于资产类型，5个大类不可选
            el.disabled = true;
          } else if (selectable === 'leafNotRootNode') {
            // 末级节点非根节点可选（只有末级节点可选，如果只有一个根节点，则不可选）
            if (el.childrenNode && el.childrenNode.length || levelType === 1) {
              el.disabled = true;
            }
          }
        } else {
          if (el.childrenNode && el.childrenNode.length) {
            el.disabled = true;
          }
        }

        return /*#__PURE__*/_react["default"].createElement(TreeNode, {
          value: el[value || 'value'],
          $item: el,
          disabled: el.disabled,
          title: el[name || 'name'],
          key: "".concat(el[value || 'value'])
        }, _this.renderCategoryModelNodeTree(el.childrenNode || [], config));
      });
    });

    return _this;
  }

  _createClass(CommonForm, [{
    key: "render",
    value:
    /**
     * 表单内容，根据传入的column可判断需要渲染成几列显示的表单，默认一列
     */
    function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          fields = _this$props3.fields,
          column = _this$props3.column;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "PopoverInput"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "form-content"
      }, /*#__PURE__*/_react["default"].createElement(_antd.Form, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: "form-wrap"
      }, (0, _lodash.chunk)(fields, column).map(function (el, idx) {
        return el.map(function (it, i) {
          return it.type !== 'hidden' ? /*#__PURE__*/_react["default"].createElement(_antd.Col, {
            key: it.key,
            span: 24 / column
          }, _this2.renderFormItem(it, i)) : _this2.renderFormItem(it, i);
        });
      })))));
    }
  }]);

  return CommonForm;
}(_react.PureComponent);

CommonForm.propTypes = {};
CommonForm.defaultProps = {};
var _default = CommonForm;
exports["default"] = _default;