"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Search2 = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _common = require("../../utils/common");

var _lodash = _interopRequireDefault(require("lodash"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./index.less");

var _DateRange = _interopRequireDefault(require("../DateRange"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Item = _antd.Form.Item;
var SHOW_ALL = _antd.TreeSelect.SHOW_ALL,
    SHOW_PARENT = _antd.TreeSelect.SHOW_PARENT,
    SHOW_CHILD = _antd.TreeSelect.SHOW_CHILD,
    TreeNode = _antd.TreeSelect.TreeNode;
var Option = _antd.Select.Option;
var TREE_SHOW = {
  'all': SHOW_ALL,
  'parent': SHOW_PARENT,
  'child': SHOW_CHILD
}; // 指定的2列宽的查询字段
// const spans = ['multipleQuery', 'categoryModel', 'dateRange']

var spans = [];
var defaultFieldsInit = [{
  label: '综合查询',
  maxLength: 30,
  className: '',
  key: 'multipleQuery',
  span: 12,
  style: {
    width: 638
  },
  type: 'input',
  placeholder: '名称/编号/IP'
}];
var effectsEvent = ['reset']; // const fieldListInit = [
//   { label: '单选', key: 'select', type: 'select', placeholder: '请选择', data: [ { label: 'a', value: 'a' } ] },
//   { label: '单选', key: 'select1', type: 'select', placeholder: '请选择', data: [ { label: 'a', value: 'a' } ] },
//   { label: '单选', key: 'select2', type: 'select', placeholder: '请选择', data: [ { label: 'a', value: 'a' } ] },
//   { label: '查询时间', key: 'dateRange', type: 'dateRange', placeholder: ['开始日期', '结束日期'], data: [ ] },
//   { label: '资产类型', key: 'categoryModel', multiple: false, getChildrenKeys: true, config: { name: 'fullName', value: 'stringId' }, type: 'treeSelect', placeholder: '请选择', data: initData.selectTreeData }
// ]

/**
 * 注意：
 * props defaultFields { Array } 默认查询条件， 参考fieldList
 * props fieldList {Array} 查询条件的列表
 *        [
 *          {
 *            label: '', // 查询条件的显示名称
 *            key: '', // 查询条件的字段名
 *            type: 'select | dateRange | input | treeSelect | date | checkboxGroup',  // 查询条件的表单类型
 *            placeholder: String | [ String, String ] // 普通类型的是字符串，range类型为数组
 *            data: Array | Object 为选择类型表单的 下拉值，  Array: 是select 类型的 options， Object：是treeSelect的下拉选项
 *            multiple: Boolean, // 是否是对选，正对与下拉框选项有效
 *            getChildrenKeys: Boolean, // 是否获取下级及其后代节点的value，
 *            config: { name: String, value: String }, // name为下拉框类型表单的属性字段名，默认为name， value为下拉框类型表单的id属性字段名，默认为value
 *          }
 *        ]
 * props  onSubmit { Function } 查询提交时的回调函数
 * props  column { Number } 分多少列渲染
 * props  setDefaultExpandedStatus { Boolean } 查询栏的默认展开状态
 * props  onChange { Function } 任意查询条件改变时的回调函数  注意，此函数不能设置props，否则将进入死循环
 * props  onExpand { Function } 查询栏展开事件
 */

var Search2 = /*#__PURE__*/function (_Component) {
  _inherits(Search2, _Component);

  var _super = _createSuper(Search2);

  function Search2(props) {
    var _this;

    _classCallCheck(this, Search2);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "onExpand", function () {
      var onExpand = _this.props.onExpand;
      var conditionShow = _this.state.conditionShow;

      _this.setState({
        conditionShow: !conditionShow
      });

      onExpand && onExpand(!conditionShow); //展开查询条件时，加载下拉框数据

      if (!conditionShow) {} else {// this.handleReset()
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setDefaultExpandedStatus", function (defaultExpanded) {
      // 初始化时，并且状态为布尔时
      if (_this.isDefault && typeof defaultExpanded === 'boolean') {
        _this.isDefault = false;

        _this.setState({
          conditionShow: defaultExpanded
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onChange", function () {
      _this.getFieldsValues().then(function (values) {
        var onChange = _this.props.onChange;
        onChange && onChange(values);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onSubmit", function () {
      _this.getFieldsValues().then(function (values) {
        var onSubmit = _this.props.onSubmit;
        onSubmit && onSubmit(values);
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getFieldsValues", function () {
      return new Promise(function (resolve) {
        _this.props.form.validateFields(function (err, values) {
          if (!err) {
            var fieldList = _this.props.fieldList;

            var params = _objectSpread({}, values); // 找出那些是要遍历子节点的ID的


            var _fieldList = fieldList.filter(function (e) {
              return e.getChildrenKeys;
            }); // 需要遍历子节点的


            if (_fieldList.length) {
              _fieldList.forEach(function (e) {
                // Set 去重
                params[e.key] = _toConsumableArray(new Set(values[e.key] ? (0, _common.subNodeQuery)(e.data)(Array.isArray(values[e.key]) ? values[e.key] : [values[e.key]]) : values[e.key]));
              });
            }

            resolve(params);
          }
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleSubmit", function (e) {
      e.preventDefault();

      _this.onSubmit();
    });

    _defineProperty(_assertThisInitialized(_this), "_renderFormItem", function () {
      var fieldList = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var column = arguments.length > 1 ? arguments[1] : undefined;
      var isDefaultFields = arguments.length > 2 ? arguments[2] : undefined;
      return _lodash["default"].chunk(fieldList.filter(function (e) {
        return e.check ? e.check(e) : true;
      }), column).map(function (row, i) {
        return row.map(function (el, idx) {
          // 查询和重置按钮是否有marginLeft
          if (isDefaultFields) {
            _this.searcBtnMarginleft = false;
          }

          var ItemClassName = ''; // 真正的fileds，排除supplierLine2、supplierLine1

          if (el.key && fieldList.find(function (e) {
            return e.type !== 'supplierLine1' && e.type !== 'supplierLine2';
          })) {
            var filterFields = _lodash["default"].chunk(fieldList.filter(function (e) {
              return e.check ? e.check(e) : true;
            }).filter(function (e) {
              return e.type !== 'supplierLine1' && e.type !== 'supplierLine2';
            }), column);

            if (Array.isArray(filterFields[0])) {
              for (var _i = 0, Ilen = filterFields.length; _i < Ilen; ++_i) {
                for (var j = 0, Jlen = filterFields[_i].length; j < Jlen; ++j) {
                  if (filterFields[_i][j].key === el.key) {
                    if (Jlen === 2 && j === 1 || j !== 0 && j !== Jlen - 1) {
                      ItemClassName = ' search-item-separation ';

                      if (_i === Ilen - 1 && column > 1 && isDefaultFields) {
                        _this.searcBtnMarginleft = true;
                      }
                    }
                  }
                }
              }
            }
          }

          return _this.renderComponent(el, idx, fieldList, row.length, ItemClassName);
        });
      });
    });

    _defineProperty(_assertThisInitialized(_this), "renderComponent", function () {
      var el = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var idx = arguments.length > 1 ? arguments[1] : undefined;
      var fieldList = arguments.length > 2 ? arguments[2] : undefined;
      var len = arguments.length > 3 ? arguments[3] : undefined;
      var ItemClassName = arguments.length > 4 ? arguments[4] : undefined;
      var getFieldDecorator = _this.props.form.getFieldDecorator;

      var type = el.type,
          _el$label = el.label,
          label = _el$label === void 0 ? '' : _el$label,
          initialValue = el.initialValue,
          rules = el.rules,
          span = el.span,
          key = el.key,
          placeholder = el.placeholder,
          style = el.style,
          data = el.data,
          config = el.config,
          _el$multiple = el.multiple,
          multiple = _el$multiple === void 0 ? false : _el$multiple,
          _el$effects = el.effects,
          effects = _el$effects === void 0 ? [] : _el$effects,
          _el$treeCheckable = el.treeCheckable,
          treeCheckable = _el$treeCheckable === void 0 ? 1 : _el$treeCheckable,
          _el$showCheckedStrate = el.showCheckedStrategy,
          showCheckedStrategy = _el$showCheckedStrate === void 0 ? 'parent' : _el$showCheckedStrate,
          _el$showSearch = el.showSearch,
          showSearch = _el$showSearch === void 0 ? true : _el$showSearch,
          _el$treeDefaultExpand = el.treeDefaultExpandAll,
          treeDefaultExpandAll = _el$treeDefaultExpand === void 0 ? true : _el$treeDefaultExpand,
          onSearch = el.onSearch,
          other = _objectWithoutProperties(el, ["type", "label", "initialValue", "rules", "span", "key", "placeholder", "style", "data", "config", "multiple", "effects", "treeCheckable", "showCheckedStrategy", "showSearch", "treeDefaultExpandAll", "onSearch"]);

      var _ref = config || {},
          name = _ref.name,
          value = _ref.value;

      var component = null; // 当前列占用几列

      var _span = spans.includes(type) ? 12 : span || 6;

      var formLayout = {};

      if (_span === 12) {// formLayout = { ...formLayout1 }
      } else {// formLayout = { ...formLayout2 }
        }

      var formItemClass = 'search-from-item ' + ItemClassName;

      switch (type) {
        case 'input':
          {
            // const _style = { width: key === 'multipleQuery' ? 638 : 240 }
            var _style = {};
            component = /*#__PURE__*/_react["default"].createElement(Item, _extends({
              label: label ? "".concat(label, ":") : ''
            }, other, formLayout, {
              key: label,
              className: formItemClass
            }), getFieldDecorator(key, {
              rules: rules,
              initialValue: initialValue
            })( /*#__PURE__*/_react["default"].createElement(_antd.Input, _extends({
              autoComplete: "off",
              placeholder: placeholder || '请输入',
              style: _objectSpread(_objectSpread({}, style), _style),
              className: el.className
            }, other))));
            break;
          }

        case 'select':
          {
            var mode = multiple ? {
              mode: 'multiple'
            } : {};
            var _data = data;
            var option = {
              initialValue: initialValue
            };
            var allowClear = multiple ? true : false;
            var v = null; // 多选没有全部选项

            if (!multiple) {
              var _ref2;

              _data = (data || []).filter(function (e) {
                return e[name || 'name'] === '全部';
              }).length ? data : [(_ref2 = {}, _defineProperty(_ref2, name || 'name', '全部'), _defineProperty(_ref2, value || 'value', v), _ref2)].concat(_toConsumableArray(data));

              if (!initialValue) {
                option = {
                  initialValue: v
                };
              }
            }

            component = /*#__PURE__*/_react["default"].createElement(Item, _extends({
              label: label ? "".concat(label, ":") : ''
            }, formLayout, {
              key: label,
              className: formItemClass,
              style: _objectSpread({}, style)
            }), getFieldDecorator(key, option)( /*#__PURE__*/_react["default"].createElement(_antd.Select, _extends({
              allowClear: allowClear,
              getPopupContainer: function getPopupContainer(triggerNode) {
                return triggerNode.parentNode;
              },
              placeholder: placeholder || '请选择',
              optionFilterProp: "label",
              showSearch: showSearch,
              onSearch: onSearch
            }, style, other, mode), _data.map(function (e, i) {
              return /*#__PURE__*/_react["default"].createElement(Option, {
                key: i,
                value: e[value || 'value'],
                label: e[name || 'name']
              }, e[name || 'name']);
            }))));
            break;
          }

        case 'treeSelect':
          {
            var _onChange = other.onChange,
                _other = _objectWithoutProperties(other, ["onChange"]);

            var className = 'filter-form-item ' + el.className;
            component = /*#__PURE__*/_react["default"].createElement(Item, _extends({
              label: label ? "".concat(label, ":") : ''
            }, formLayout, {
              key: label,
              className: formItemClass
            }), getFieldDecorator(key, {
              initialValue: initialValue
            })( /*#__PURE__*/_react["default"].createElement(_antd.TreeSelect, _extends({
              allowClear: true,
              getPopupContainer: function getPopupContainer(triggerNode) {
                return triggerNode.parentNode;
              } // style={{ width: 174 }}
              ,
              style: _objectSpread({}, style),
              dropdownStyle: {
                maxHeight: 400,
                overflow: 'auto'
              },
              placeholder: placeholder || '请选择' // style={{ width: '100%' }}
              ,
              multiple: multiple,
              initialValue: initialValue,
              onChange: function onChange(val, lab, extra) {
                // 特殊影响事件，在特征库、版本库影响到了版本的选择
                if (effects.length) {
                  effects.forEach(function (effect) {
                    if (effect.key) {
                      var hasEvent = _lodash["default"].intersection(effect.event || [], effectsEvent) || [];

                      if (hasEvent.length) {
                        hasEvent.forEach(function (event) {
                          _this.eventFunction[event](effect.key);
                        });
                      }
                    }
                  });
                }

                _onChange && _onChange(val, lab, extra);
              },
              treeDefaultExpandAll: treeDefaultExpandAll,
              showCheckedStrategy: TREE_SHOW[showCheckedStrategy],
              treeCheckable: treeCheckable === 1 ? false : treeCheckable,
              treeNodeFilterProp: "title",
              showSearch: showSearch,
              onSearch: onSearch
            }, style, _other, {
              className: className
            }), _this.renderCategoryModelNodeTree(data, {
              name: name,
              value: value
            }))));
            break;
          }

        case 'date':
          {
            component = /*#__PURE__*/_react["default"].createElement(Item, _extends({
              label: label ? "".concat(label, ":") : ''
            }, other, formLayout, {
              key: label,
              className: formItemClass
            }), getFieldDecorator(key, {
              rules: rules,
              initialValue: initialValue
            })( /*#__PURE__*/_react["default"].createElement(_antd.DatePicker, _extends({
              getCalendarContainer: function getCalendarContainer(triggerNode) {
                return triggerNode.parentNode;
              }
            }, other, {
              className: "form-item-warp"
            })) // <DatePickerInput popover={popover} other={other}/>
            ));
            break;
          }

        case 'dateRange':
          {
            component = /*#__PURE__*/_react["default"].createElement(Item, _extends({
              label: label ? "".concat(label, ":") : ''
            }, formLayout, {
              key: label,
              className: formItemClass
            }), getFieldDecorator(key)( /*#__PURE__*/_react["default"].createElement(_DateRange["default"], _extends({
              placeholder: placeholder,
              style: _objectSpread({
                width: 638
              }, style),
              resetKey: _this.randomKey,
              className: "filter-form-item"
            }, other))));
            break;
          }

        case 'supplierLine1':
          {
            var _other$subfieldTitle = other.subfieldTitle,
                subfieldTitle = _other$subfieldTitle === void 0 ? true : _other$subfieldTitle,
                _other$showLine = other.showLine,
                showLine = _other$showLine === void 0 ? true : _other$showLine;
            component = /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
              className: "line",
              style: {
                visibility: showLine ? 'visible' : 'hidden'
              }
            }), subfieldTitle && /*#__PURE__*/_react["default"].createElement("p", {
              style: _objectSpread({}, style)
            }, "\u5173\u8054\u8BBE\u5907"));
            break;
          }

        case 'supplierLine2':
          {
            component = /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
              className: "line2"
            }));
            break;
          }

        case 'checkboxGroup':
          {
            component = /*#__PURE__*/_react["default"].createElement(Item, _extends({
              label: label ? "".concat(label) : ''
            }, formLayout, {
              key: label,
              className: formItemClass
            }), getFieldDecorator(key)( /*#__PURE__*/_react["default"].createElement(_antd.Checkbox.Group, _extends({
              options: data || []
            }, other))));
            break;
          }

        default:
          return null;
      }

      return component;
    });

    _defineProperty(_assertThisInitialized(_this), "handleReset", function () {
      var keys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var _this$props = _this.props,
          _this$props$fieldList = _this$props.fieldList,
          fieldList = _this$props$fieldList === void 0 ? [] : _this$props$fieldList,
          defaultFields = _this$props.defaultFields,
          form = _this$props.form,
          onReset = _this$props.onReset;
      var fieldKeys = [].concat([], fieldList, defaultFields).filter(function (e) {
        return e.check ? e.check(e) : true;
      }).map(function (e) {
        return e.key;
      });
      var resetKeys = keys.concat(fieldKeys);
      resetKeys.length && form.resetFields(resetKeys); // 重置时，需要手动重置

      if (_this.manualResetFiled.includes('dateRange')) {
        _this.randomKey = Math.random();
      }

      if (onReset) {
        onReset();
      } else {
        _this.onSubmit();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "renderCategoryModelNodeTree", function (data) {
      var config = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var nodeType = Object.prototype.toString.call(data);

      if (nodeType === '[object Object]') {
        return data ? /*#__PURE__*/_react["default"].createElement(TreeNode, {
          value: data[config.value || 'stringId'],
          title: data[config.name || 'name'],
          key: "".concat(data[config.value || 'value'])
        }, data.childrenNode && data.childrenNode.length ? data.childrenNode.map(function (item) {
          return _this.renderCategoryModelNodeTree(item, config);
        }) : void 0) : void 0;
      }

      if (nodeType === '[object Array]') {
        return !!data.length ? data.map(function (ite, i) {
          return /*#__PURE__*/_react["default"].createElement(TreeNode, {
            value: ite[config.value || 'stringId'],
            title: ite[config.name || 'name'],
            key: "".concat(ite[config.value || 'value'])
          }, ite.childrenNode && ite.childrenNode.length ? ite.childrenNode.map(function (item) {
            return _this.renderCategoryModelNodeTree(item, config);
          }) : void 0);
        }) : void 0;
      }

      return void 0;
    });

    _defineProperty(_assertThisInitialized(_this), "pullAway", function (fields) {
      var list = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
      var arr = [];
      var last = [];
      fields.forEach(function (el) {
        if (!list.includes(el.key)) {
          arr.push(el);
        } else {
          last.push(el);
        }
      });
      return arr.concat(last);
    });

    _defineProperty(_assertThisInitialized(_this), "setBtnsMarginleft", function () {
      var defaultFields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var column = arguments.length > 1 ? arguments[1] : undefined;

      // 获取行列数据
      var list = _lodash["default"].chunk(defaultFields.filter(function (e) {
        return e.check ? e.check(e) : true;
      }), column); // 只有一行时


      if (list.length === 1) {
        // 只有一列时,按钮设置margin-left值
        if (list[0].length === 1) {
          return true;
        } else {
          return false;
        }
      } else if (list.length > 1) {
        // 多行时
        // 最后一行只有一列时,按钮设置margin-left值
        if (list[list.length - 1].length === 1) {
          return true;
        } else {
          return false;
        }
      }
    });

    _this.state = {
      conditionShow: false
    }; // 点击重置按钮时，需要手动重置状态的

    _this.manualResetFiled = ['dateRange'];
    _this.randomKey = Math.random();
    _this.isDefault = true;
    _this.eventFunction = {
      reset: function reset() {
        var arr = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        var resetFields = _this.props.form.resetFields;
        resetFields(arr);
      }
    };
    return _this;
  }

  _createClass(Search2, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.showsearch) {
        this.setState({
          conditionShow: true
        });
      }

      var setDefaultExpandedStatus = this.props.setDefaultExpandedStatus;
      this.setDefaultExpandedStatus(setDefaultExpandedStatus);
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var setDefaultExpandedStatus = nextProps.setDefaultExpandedStatus;
      this.setDefaultExpandedStatus(setDefaultExpandedStatus);
    } //展开搜索条件

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          fieldList = _this$props2.fieldList,
          defaultFields = _this$props2.defaultFields,
          column = _this$props2.column,
          _this$props2$showExpa = _this$props2.showExpand,
          showExpand = _this$props2$showExpa === void 0 ? true : _this$props2$showExpa;
      var conditionShow = this.state.conditionShow; // const column = 4

      var fields = this.pullAway(fieldList, ['dateRange']); // const _fieldList = _.chunk(fields, column)

      var _fieldList = fields;
      this.onChange(); // const isMarginLeft = this.setBtnsMarginleft(defaultFields, column) ? '' : 'search-from-no-margin-left'

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: "custom-form"
      }, /*#__PURE__*/_react["default"].createElement(_antd.Form, {
        className: "filter-form",
        layout: "inline",
        onSubmit: this.handleSubmit
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "default-filter-item"
      }, this._renderFormItem(defaultFields, column, true), /*#__PURE__*/_react["default"].createElement(Item, {
        className: "search-item search-more-item search-from-btn ".concat(this.searcBtnMarginleft ? 'search-from-no-margin-left' : '')
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "search-from-btn-content"
      }, /*#__PURE__*/_react["default"].createElement(_antd.Button, {
        type: "primary",
        htmlType: "submit"
      }, "\u67E5\u8BE2"), /*#__PURE__*/_react["default"].createElement(_antd.Button, {
        onClick: function onClick() {
          return _this2.handleReset();
        }
      }, "\u91CD\u7F6E"), fields.length && showExpand ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "show-ondition",
        onClick: this.onExpand
      }, /*#__PURE__*/_react["default"].createElement(_antd.Icon, {
        type: conditionShow ? 'up' : 'down'
      }), conditionShow ? '收起' : '高级查询') : null))), /*#__PURE__*/_react["default"].createElement("div", {
        className: 'hide-form ' + (conditionShow || !showExpand ? 'flex' : 'none')
      }, this._renderFormItem(_fieldList, column))));
    }
  }]);

  return Search2;
}(_react.Component);

exports.Search2 = Search2;

_defineProperty(Search2, "defaultProps", {
  fieldList: [],
  column: 3,
  // 分多少列渲染
  defaultFields: defaultFieldsInit
});

_defineProperty(Search2, "propTypes", {
  fieldList: _propTypes["default"].array,
  defaultFields: _propTypes["default"].array
});

var Search = _antd.Form.create()(Search2);

var _default = Search;
exports["default"] = _default;